AllYourBase = {}
local AYB = AllYourBase

AYB.Constants = {}
AYB.Constants.CurrentVersion = "0.1.1"
AYB.Constants.hasLoggedIn = false
AYB.Constants.debugLast = "Nothing"
AYB.Constants.isCrafterOpen = false
AYB.Constants.lastCrafterOpen = 0
AYB.Constants.shouldSyncShipments = false
local last = AYB.Constants.debugLast

AYB.Shipments = {}

local me, race, faction

AYB.CompletedQueue = {}

AYB.Main = CreateFrame("Frame","AllYourBaseMain")
AYB.Main.Timer = 0

AYB.ShipmentUpdater = CreateFrame("Frame", "AllYourBaseShipmentUpdater")
AYB.WhichCrafter = CreateFrame("Frame", "AllYourBaseDetermineCrafter")

for k, v in pairs({
	"ADDON_LOADED",
	"PLAYER_ENTERING_WORLD",
	"SHIPMENT_CRAFTER_CLOSED",
-- 	"SHIPMENT_CRAFTER_INFO",
	"SHIPMENT_CRAFTER_OPENED",
	"SHIPMENT_CRAFTER_REAGENT_UPDATE",
	"SHIPMENT_UPDATE",
	"GARRISON_ARCHITECT_CLOSED",
	"GARRISON_ARCHITECT_OPENED",
	"GARRISON_BUILDINGS_SWAPPED",
	"GARRISON_BUILDING_ACTIVATABLE",
	"GARRISON_BUILDING_ACTIVATED",
	"GARRISON_BUILDING_ERROR",
	"GARRISON_BUILDING_LIST_UPDATE",
	"GARRISON_BUILDING_PLACED",
	"GARRISON_BUILDING_REMOVED",
	"GARRISON_BUILDING_UPDATE",
	"GARRISON_FOLLOWER_ADDED",
	"GARRISON_FOLLOWER_LIST_UPDATE",
	"GARRISON_FOLLOWER_REMOVED",
	"GARRISON_FOLLOWER_XP_CHANGED",
	"GARRISON_HIDE_LANDING_PAGE",
	"GARRISON_INVASION_AVAILABLE",
	"GARRISON_INVASION_UNAVAILABLE",
	"GARRISON_LANDINGPAGE_SHIPMENTS",
	"GARRISON_MISSION_BONUS_ROLL_COMPLETE",
	"GARRISON_MISSION_BONUS_ROLL_LOOT",
	"GARRISON_MISSION_COMPLETE_RESPONSE",
	"GARRISON_MISSION_FINISHED",
	"GARRISON_MISSION_LIST_UPDATE",
	"GARRISON_MISSION_NPC_CLOSED",
	"GARRISON_MISSION_NPC_OPENED",
	"GARRISON_MISSION_STARTED",
	"GARRISON_MONUMENT_CLOSE_UI",	
	"GARRISON_MONUMENT_LIST_LOADED",
	"GARRISON_MONUMENT_REPLACED",
	"GARRISON_MONUMENT_SELECTED_TROPHY_ID_LOADED",
	"GARRISON_MONUMENT_SHOW_UI",
	"GARRISON_RECALL_PORTAL_LAST_USED_TIME",
	"GARRISON_RECALL_PORTAL_USED",
	"GARRISON_RECRUITMENT_FOLLOWERS_GENERATED",
	"GARRISON_RECRUITMENT_NPC_CLOSED",
	"GARRISON_RECRUITMENT_NPC_OPENED",
	"GARRISON_RECRUITMENT_READY",
	"GARRISON_RECRUIT_FOLLOWER_RESULT",
	"GARRISON_SHOW_LANDING_PAGE",
	"GARRISON_TRADESKILL_NPC_CLOSED",
	"GARRISON_UPDATE",
	"GARRISON_UPGRADEABLE_RESULT",
	"GARRISON_USE_PARTY_GARRISON_CHANGED",
	"SHIPMENT_UPDATE"}) do AYB.Main:RegisterEvent(v) end

AYB.WhichCrafter:RegisterEvent("SHIPMENT_CRAFTER_INFO")
	
function AYB.Main.OnEvent(self, event, ...)
	if event == "GARRISON_LANDINGPAGE_SHIPMENTS" then
		-- AYB.FakeWhisper(UnitName("player"), event)
	elseif event == "GARRISON_MISSION_STARTED" then
		AYB.StartMission(...)
	elseif event == "GARRISON_BUILDING_PLACED" then
		AYB.StartBuilding(false, ...)
	elseif event == "GARRISON_BUILDING_REMOVED" then
		AYB.StartBuilding(true, ...)
	elseif event == "GARRISON_MISSION_COMPLETE_RESPONSE" then
		AYB.RemoveCompletedMission(...)
	elseif event == "GARRISON_BUILDING_ACTIVATED" then
		AYB.RemoveCompletedBuilding(...)
	elseif event == "ADDON_LOADED" then
		if ... == "AllYourBase" then
			me = UnitName("player").."-"..GetRealmName()
			race = select(2, UnitRace("player"))
			faction = UnitFactionGroup("player")
			if (not AllYourBaseVars) or (AllYourBaseVars.CurrentVersion ~= AYB.Constants.CurrentVersion) then
				AllYourBaseVars = {}
				AllYourBaseVars.CurrentVersion = AYB.Constants.CurrentVersion
			end
			if not AllYourBaseVars[me] then
				AllYourBaseVars[me] = {
					["Buildings"] = {},
					["Shipments"] = {},
					["Missions"] = {},
					["Followers"] = {},
					["Race"] = race
				}
			end
		end
	elseif event == "PLAYER_ENTERING_WORLD" then
		LoadAddOn("Blizzard_GarrisonUI")
		if not AYB.Constants.hasLoggedIn then -- only force show the frame once, at log-in, to trigger the message.
			AYB.Main:Show()
			last = "Showing main frame from PEW"
		end
		AYB.ShipmentUpdater:Hide()
		AYB.ShipmentUpdater.Timer = 0
		AYB.CleanUpUnusedEntries("Missions")
		AYB.CleanUpUnusedEntries("Buildings")

	elseif event == "GARRISON_MISSION_NPC_OPENED" or event == "GARRISON_ARCHITECT_OPENED" then -- when in the mission UI, suspend syncing, otherwise the information can get re-added between completing a mission and opening the loot chest
		AYB.Main:Hide()
	elseif event == "GARRISON_MISSION_NPC_CLOSED" or event == "GARRISON_ARCHITECT_CLOSED" then -- resume sync when the UI is closed
		AYB.Main:Show()
	elseif event == "SHIPMENT_UPDATE" and ... then
	--	AYB.Print(event)
	--	AYB.ShipmentUpdater.Timer = 0
	--	AYB.ShipmentUpdater:Show()
		if AYB.Constants.isCrafterOpen then
			AYB.Constants.shouldSyncShipments = true
		end
	elseif event == "SHIPMENT_CRAFTER_OPENED" then
		-- print(event)
		AYB.WhichCrafter:Show()
		AYB.Constants.isCrafterOpen = true
		-- AYB.Print("It's open.")
	elseif event == "SHIPMENT_CRAFTER_CLOSED" then
		-- print(event)
		-- AYB.TrueUpShipmentQueue(AYB.Constants.lastCrafterOpen)
		AYB.WhichCrafter:Hide()		
		AYB.Constants.isCrafterOpen = false
		-- AYB.Print("It's not open.")
		if AYB.Constants.shouldSyncShipments then
			AYB.Constants.shouldSyncShipments = false
			C_Garrison.RequestLandingPageShipmentInfo()
			GarrisonLandingPageReport_GetShipments(GarrisonLandingPageReport)
			AYB.ShipmentUpdater.Timer = 0
			AYB.ShipmentUpdater:Show()
		end
	elseif event == "GARRISON_SHOW_LANDING_PAGE" then
		if not AllYourBaseStatusButton then
			AYB.StatusButton = CreateFrame("Button", "AllYourBaseStatusButton", GarrisonLandingPage, "UIPanelButtonTemplate")
			local statusButton = AYB.StatusButton
			statusButton:SetText("Status Report")
			statusButton:SetHeight(20)
			statusButton:SetWidth(110)
			statusButton:SetPoint("TOPLEFT", 363, -15)
			statusButton:SetFrameLevel(14)
			statusButton:Show()
			statusButton:SetScript("OnClick", function() AYB.SlashHandler("status") end)
		end
		if not AllYourBaseNextButton then
			AYB.NextButton = CreateFrame("Button", "AllYourBaseNextButton", GarrisonLandingPage, "UIPanelButtonTemplate")
			local nextButton = AYB.NextButton
			nextButton:SetText("Who's Next?")
			nextButton:SetHeight(20)
			nextButton:SetWidth(110)
			nextButton:SetPoint("TOPLEFT", 513, -15)
			nextButton:SetFrameLevel(14)
			nextButton:Show()
			nextButton:SetScript("OnClick", function() AYB.SlashHandler("next") end)
		end
		
	--[[
	elseif event ~= "SHIPMENT_UPDATE" then
		print(event, ...)		
	--]]
	end
end

--[[
function AYB.WhichCrafter.OnEvent(self, event, ...)
	if event == "SHIPMENT_CRAFTER_INFO" then
		AYB.ParseCrafter(...)
	end
end
]]

function AYB.ParseCrafter(self, event, success, queued, total, plotID)
	-- AYB.Print("parsing")
	local buildingID
	for k, v in ipairs(C_Garrison.GetBuildings()) do
		if v.plotID == plotID then
			buildingID = v.buildingID
			break
		end
	end
	AYB.Constants.lastCrafterOpen = buildingID
	-- AYB.Print("Parser makes lastCrafter ".. AYB.BuildingIDsToNames[buildingID][faction])
	-- AYB.TrueUpShipmentQueue(buildingID)
end

--[[
function AYB.TrueUpShipmentQueue(buildingID)
	-- print(buildingID)
	local name, texture, shipmentCapacity, shipmentsReady, shipmentsTotal, creationTime, duration, timeleftString, itemName, itemIcon, itemQuality, itemID = C_Garrison.GetLandingPageShipmentInfo(buildingID)
	-- print(name)
	-- print(format("%s has %d ready out of %d, the last one was created %s mins ago and will be ready in %s.", name, shipmentsReady, shipmentsTotal, (time() - creationTime)/60, AYB.SecsToText((4 * 3600) - time() + creationTime)))
	-- print(format("The last shipment will be ready in %s", AYB.SecsToText((shipmentsTotal - shipmentsReady)*3600*4 + time() - creationTime)))
	local endTime = (creationTime and ((shipmentsTotal - shipmentsReady )*3600*4 + creationTime)) or time()
	AllYourBaseVars[me].Shipments[name] = {["endTime"] = endTime, ["hasBroadcast"] = false}
end
]]

function AYB.Main.OnUpdate(self, timer)
	AYB.Main.Timer = AYB.Main.Timer + timer
	if AYB.Main.Timer >= 5 then
		AYB.Main.Timer = 0
		AYB.Sync()
	end
end

function AYB.ShipmentUpdater.OnUpdate(self, elapsed)
	AYB.ShipmentUpdater.Timer = AYB.ShipmentUpdater.Timer + elapsed
	if AYB.ShipmentUpdater.Timer >= 2 then
		AYB.StartShipment(AYB.Constants.lastCrafterOpen)
		AYB.ShipmentUpdater.Timer = 0
		AYB.ShipmentUpdater:Hide()
	end
end

function AYB.SlashHandler(msg)
	local cmd = string.lower(msg)
	if cmd == "next" then
		AYB.NextToComplete("Missions")
		AYB.NextToComplete("Buildings")
		AYB.NextToComplete("Shipments")
	elseif cmd == "next mission" then
		AYB.NextToComplete("Missions")
	elseif cmd == "next shipment" then
		AYB.NextToComplete("Shipments")
	elseif cmd == "next building" then
		AYB.NextToComplete("Buildings")
	elseif cmd == "missions" then
		AYB.SearchAllForCompleteMissions(true, "from slash")
	elseif cmd == "buildings" then 
		AYB.SearchAllForCompleteBuildings(true, "from slash")
	elseif cmd == "shipments" then
		AYB.DisplayCompletedShipmentReport()
	elseif cmd == "status" then
		AYB.CompletedQueue = {}
		AYB.SearchAllForCompleteMissions(true, "from slash")
		AYB.SearchAllForCompleteBuildings(true, "from slash")
		AYB.SearchAllForCompleteShipments(true, "from slash")
	else
		AYB.Print("Don't know what that means.")
	end
end

function AYB.StartMission(...)
	local started = ...
	for k, v in ipairs(C_Garrison.GetLandingPageItems()) do
		if v.missionID == started then
			AllYourBaseVars[me].Missions[started] = v
			AllYourBaseVars[me].Missions[started].startTime = time()
			AllYourBaseVars[me].Missions[started].endTime = time() + AYB.TextToSecs(v.timeLeft)
			AllYourBaseVars[me].Missions[started].hasBroadcast = false
		end
	end
end

function AYB.StartBuilding(hasRemoved, ...)
	local arg1, arg2 = ...
	local oldBuilding
	if hasRemoved then
		oldBuilding = AllYourBase.BuildingIDsToNames[arg2][faction]
	end
	if oldBuilding and AllYourBaseVars[me].Buildings[oldBuilding] then
		AllYourBaseVars[me].Buildings[oldBuilding] = nil
	end		
	for k, v in ipairs(C_Garrison.GetLandingPageItems()) do
		if v.isBuilding then
			if not AllYourBaseVars[me].Buildings[v.name] then
				AllYourBaseVars[me].Buildings[v.name] = v
				AllYourBaseVars[me].Buildings[v.name].startTime = time()
				AllYourBaseVars[me].Buildings[v.name].hasBroadcast = false
				AllYourBaseVars[me].Buildings[v.name].endTime = time() + AYB.TextToSecs(v.timeLeft)
			end
		end
	end
end

function AYB.StartShipment(crafter)
	--local buildings, shipments = C_Garrison.GetBuildings(), {}
	local s = {C_Garrison.GetLandingPageShipmentInfo(crafter)}
	local building = AllYourBase.BuildingIDsToNames[crafter][faction]
	--[[
	for i = 1, #buildings do
		local buildingID = buildings[i].buildingID
		if buildingID then
			-- local name, texture, shipmentCapacity, shipmentsReady, shipmentsTotal, creationTime, duration, timeleftString, itemName, itemIcon, itemQuality, itemID = C_Garrison.GetLandingPageShipmentInfo(buildingID);
			shipments[buildingID] = {C_Garrison.GetLandingPageShipmentInfo(buildingID)}
		end
	end
	local t, n = 0, 0
	for k, v in pairs(shipments) do
		if v[5] then
			t = t + v[5]
			n = n + 1
		end
	end
	]]
	-- AYB.Print("starting shipment from "..building)
	-- AYB.Print(format("Queue status: %d ready of %d total, so %d pending. Next ready in %s, all done in %s.", s[4], s[5], s[5] - s[4], s[8], AYB.SecsToText((s[5] - s[4] - 1) * 3600 * 4 + AYB.TextToSecs(s[8]))))
	AllYourBaseVars[me].Shipments[building] = { ["endTime"] = time() + (s[5] - s[4] - 1) * 3600 * 4 + AYB.TextToSecs(s[8]) + 55, ["hasBroadcast"] = false } -- 55 is a fudge factor since the string for time left immediately starts at 3 hr 59 minutes
	AYB.Print(format("Work order queue for %s has been updated!", building))
end

function AYB.Sync()
	AYB.AddAnyMissing()
	AYB.SearchAllForCompleteMissions(not AYB.Constants.hasLoggedIn, "from Sync")
	AYB.SearchAllForCompleteBuildings(not AYB.Constants.hasLoggedIn, "from Sync")
	AYB.SearchAllForCompleteShipments(not AYB.Constants.hasLoggedIn, "from Sync")
	AYB.Constants.hasLoggedIn = true
end

function AYB.AddAnyMissing()
	for k, v in ipairs(C_Garrison.GetLandingPageItems()) do
		if v.isBuilding == false then -- if this is not a Building, it's a Mission
			if not AllYourBaseVars[me].Missions[v.missionID] then
				AllYourBaseVars[me].Missions[v.missionID] = v
				AllYourBaseVars[me].Missions[v.missionID]["startTime"] = "unknown"
				local timeLeft = C_Garrison.GetLandingPageItems()[k].timeLeft
				AllYourBaseVars[me].Missions[v.missionID].endTime = time() + AYB.TextToSecs(timeLeft)
				AllYourBaseVars[me].Missions[v.missionID].hasBroadcast = false
			end
		else -- it's a Building
			if not AllYourBaseVars[me].Buildings[v.name] then
				AllYourBaseVars[me].Buildings[v.name] = v
				AllYourBaseVars[me].Buildings[v.name]["startTime"] = "unknown"
				local timeLeft = C_Garrison.GetLandingPageItems()[k].timeLeft
				AllYourBaseVars[me].Buildings[v.name].endTime = time() + AYB.TextToSecs(timeLeft)
				AllYourBaseVars[me].Buildings[v.name].hasBroadcast = false
			end
		end
	end
end

function AYB.RemoveCompletedMission(missionID)
	AllYourBaseVars[me].Missions[missionID] = nil
end

function AYB.RemoveCompletedBuilding(...)
	local _, buildingID = ...
	local name = AYB.BuildingIDsToNames[buildingID][UnitFactionGroup("player")]
	AllYourBaseVars[me].Buildings[name] = nil
end

function AYB.NextToComplete(dataType)
	local leastTimeRemaining, whichToon, theThing = 7 * 24 * 3600
	for k, v in pairs(AllYourBaseVars) do
		if k ~= "CurrentVersion" then
			for l, w in pairs(v[dataType]) do
				if type(w) == "table" then
					local thisTimeLeft = w.endTime - time()
					if (thisTimeLeft <= leastTimeRemaining) and not (time() > w.endTime) then
						leastTimeRemaining = thisTimeLeft
						whichToon = k
						theThing = l
					end
				end
			end
		end
	end
	if whichToon then
		if whichToon == me then
			AYB.Print(format("I have the next %s, Commander! %s will be ready in %s.", string.lower(string.sub(dataType, 1, -2)), type(theThing) == "string" and theThing or "It", AYB.SecsToText(leastTimeRemaining)))
		else
			AYB.FakeWhisper(whichToon, format("%s: %s in %s.", dataType, AYB.UpNext[AllYourBaseVars[whichToon].Race], AYB.SecsToText(leastTimeRemaining)))
		end
	else
		AYB.Print(format("You have no queued %s - better start one soon!", string.lower(dataType)))
	end
end

function AYB.Print(msg)
	print(format("|cFFFFFF19All Your Base:|r %s", msg))
end

function AYB.CleanUpUnusedEntries(dataType)
	for k, v in pairs(AllYourBaseVars[me][dataType]) do
		local ID = ( dataType == "Missions" and v.missionID ) or ( dataType == "Buildings" and v.name )
		local isActive = nil
		for l, w in ipairs(C_Garrison.GetLandingPageItems()) do
			if ( dataType == "Missions" and ID == w.missionID ) or ( dataType == "Buildings" and ID == w.name ) then
				isActive = true
				break
			end
		end
		if not isActive then
			AllYourBaseVars[me][dataType][ID] = nil
		end
	end
end

function AYB.SearchAllForCompleteMissions(onDemand, last)
	local meComplete, otherComplete
	for k, v in pairs(AllYourBaseVars) do
		if k~= "CurrentVersion" then 
			for l, w in pairs(v.Missions) do
				if time() >= w.endTime and (onDemand or w.hasBroadcast == false) then
					if not onDemand then
						w.hasBroadcast = true
					end
					tinsert(AYB.CompletedQueue, k.."/"..w.missionID)
					if k == me then
						meComplete = true
					else
						otherComplete = true
					end
				end
			end
		end
	end
	-- print(format("me: %s, other: %s", meComplete and "yes" or "no", otherComplete and "yes" or "no"))
	if meComplete or otherComplete then
		if onDemand and otherComplete then
			AYB.DisplayCompletedMissionReport(last)
			AYB.CompletedQueue = {}
		elseif otherComplete then
			local toon, missionID = string.match(AYB.CompletedQueue[1], "([^/]+)/(%d+)")
			AYB.DisplayCompletedSingleMission(toon, tonumber(missionID))
			AYB.FakeWhisper(toon, "Job's done!")
			AYB.CompletedQueue = {}
		elseif onDemand and meComplete then
			AYB.Print(format("I have %d %s complete, Commander!", #AYB.CompletedQueue, #AYB.CompletedQueue > 1 and "missions" or "mission"))
			AYB.CompletedQueue = {}
		end
	elseif onDemand then
		AYB.Print("No one has any completed missions, Commander!")
	end
end

function AYB.DisplayCompletedSingleMission(char, missionID)
	GarrisonLandingPageMinimapButton.MinimapLoopPulseAnim:Play();
	local missionInfo = AllYourBaseVars[char].Missions[missionID];
	GarrisonMissionAlertFrame.Name:SetText(missionInfo.name);
	GarrisonMissionAlertFrame.MissionType:SetAtlas(missionInfo.typeAtlas);
	AlertFrame_AnimateIn(GarrisonMissionAlertFrame);
	AlertFrame_FixAnchors();
	PlaySound("UI_Garrison_Toast_MissionComplete");
end

function AYB.DisplayCompletedMissionReport(last)
	-- AYB.Print(last)
	local done, chars, toonCount, currentComplete, whichToon, msg, toon = {}, {}, 1, 0
	--[[for k, v in pairs(AllYourBaseVars[me].Missions) do
		if time() >= v.endTime then
			currentComplete = currentComplete + 1
		end
	end]]
	for k, v in ipairs(AYB.CompletedQueue) do
		toon = string.match(v, "([^/]+)")
		-- local toon = string.match(key, "([^-]+)")
		-- print(key, toon)
		if toon == me then
			currentComplete = currentComplete + 1
		else
			if not done[toon] then
				done[toon] = 0
				tinsert(chars, toon)
			end
			done[toon] = done[toon] + 1
		end
	end
	whichToon = chars[random(1, #chars)]
	local speakerRace = AllYourBaseVars[whichToon].Race
	local total = ", for a total of "..#AYB.CompletedQueue.." missions."
	local intro = AllYourBase.StatusIntros.Missions[speakerRace][random(#AllYourBase.StatusIntros.Missions[speakerRace])]
	msg = (currentComplete > 0 and (format("%s I see you have completed %d %s.", intro, currentComplete, (currentComplete == 1 and "mission" or "missions")))) or intro.." "
	for k, v in pairs(done) do
		local sp = (v == 1 and "mission") or "missions"
		local punc = (toonCount == (#chars - 1) and ", and") or "."
		local subj = (k == whichToon and "I") or k:match("([^-]+)")
		local verb = (k == whichToon and " have completed ") or " has completed "
		msg = msg.." ".. subj .. verb ..v.." ".. sp .. punc
		toonCount = toonCount + 1
	end
	msg = string.sub(msg, 1, string.len(msg) - 1).. total
	AYB.FakeWhisper(whichToon, msg)
end

function AYB.SearchAllForCompleteBuildings(onDemand, last)
	local meComplete, otherComplete
	for k, v in pairs(AllYourBaseVars) do
		if k~= "CurrentVersion" then
			for l, w in pairs(v.Buildings) do
				if time() >= w.endTime and (onDemand or w.hasBroadcast == false) then
					if not onDemand then
						w.hasBroadcast = true
					end
					tinsert(AYB.CompletedQueue, k.."/"..w.name)
					if k == me then
						meComplete = true
					else
						otherComplete = true
					end
				end
			end
		end
	end
	if meComplete or otherComplete then
		if onDemand and otherComplete then
			AYB.DisplayCompletedBuildingReport(last)
			AYB.CompletedQueue = {}
		elseif otherComplete then
			local toon, name = string.match(AYB.CompletedQueue[1], "([^/]+)/(.+)")
			AYB.FakeWhisper(toon, format("My %s is completed!", name))
			AYB.DisplayCompletedSingleBuilding(toon, name)
			tremove(AYB.CompletedQueue)
		elseif onDemand and meComplete then
			AYB.Print(format("I have %d %s complete, Commander!", #AYB.CompletedQueue, #AYB.CompletedQueue > 1 and "buildings" or "building"))
			AYB.CompletedQueue = {}
		end
	elseif onDemand then
		AYB.Print("No one has any completed buildings, Commander!")
	end
end

function AYB.DisplayCompletedSingleBuilding(toon)
	local name = toon:match("([^-]+)-.+")
	GarrisonLandingPageMinimapButton.MinimapLoopPulseAnim:Play();
	GarrisonBuildingAlertFrame.Name:SetFormattedText("%s has a finished building!", name);
	AlertFrame_AnimateIn(GarrisonBuildingAlertFrame);
	AlertFrame_FixAnchors();
	PlaySound("UI_Garrison_Toast_BuildingComplete");
end

function AYB.DisplayCompletedBuildingReport(last)
	-- AYB.Print(last)
	local done, chars, toonCount, currentComplete, whichToon, msg, toon, key, building = {}, {}, 1, 0, "", ""
	--[[for k, v in pairs(AllYourBaseVars[me].Missions) do
		if time() >= v.endTime then
			currentComplete = currentComplete + 1
		end
	end]]
	for k, v in ipairs(AYB.CompletedQueue) do
		key, building = string.match(v, "([^/]+)/(.+)")
		toon = string.match(key, "([^-]+)")
		-- print(key, building)
		if key == me then
			currentComplete = currentComplete + 1
		else
			if not done[toon] then
				done[toon] = {}
				if toon ~= string.match(me, "([^-]+)") then
					tinsert(chars, key)
				end
			end
			tinsert(done[toon], building)
		end
	end
--	print("[chars] has entries " .. #chars)
	whichToon = chars[random(1, #chars)]
	local speakerRace = AllYourBaseVars[whichToon].Race
	local total = ", for a total of "..#AYB.CompletedQueue.." buildings."
	local intro = AllYourBase.StatusIntros.Buildings[speakerRace][random(#AllYourBase.StatusIntros.Buildings[speakerRace])]
	msg = (currentComplete > 0 and (format("%s I see you have completed %d %s.", intro, currentComplete, (currentComplete == 1 and "building" or "buildings")))) or intro.." "
	for k, v in pairs(done) do
		msg = msg .. format("%s %s completed %d %s: ", (k == string.match(whichToon, "([^-]+)") and "I") or k, (k == string.match(whichToon, "([^-]+)")) and "have" or "has", #v, (#v == 1 and "building" or "buildings"))
		for l, w in ipairs(v) do
			if #v == 1 then
				msg = msg .. w .. ". "
			elseif l == #v then
				msg = msg .. "and " .. w .. ". "
			else
				msg = msg .. w .. ", "
			end
		end
	end
	AYB.FakeWhisper(whichToon, msg)
end

function AYB.SearchAllForCompleteShipments(onDemand, last)
	-- if onDemand then print("Searching for Shipments ON DEMAND") end
	local meComplete, otherComplete
	for k, v in pairs(AllYourBaseVars) do
		if k ~= "CurrentVersion" then
			for l, w in pairs(v.Shipments) do
				if time() >= w.endTime and (onDemand or not w.hasBroadcast) then
					-- print(k.."/"..l)
					if not onDemand then
						w.hasBroadcast = true
					end
					tinsert(AYB.CompletedQueue, k.."/"..l)
					if k == me then
						meComplete = true
					else
						otherComplete = true
					end
				end
			end
		end
	end
	if meComplete or otherComplete then
		if onDemand and otherComplete then
			AYB.DisplayCompletedShipmentReport(last)
			AYB.CompletedQueue = {}
		elseif otherComplete then
			local toon, building = string.match(AYB.CompletedQueue[1], "([^/]+)/(.+)")
			AYB.DisplayCompletedSingleShipment(toon)
			AYB.FakeWhisper(toon, format("My %s has finished all work orders!", building))
			AYB.CompletedQueue = {}
		elseif meComplete then
			AYB.Print(format("I have %d work order %s that %s attention, Commander!", #AYB.CompletedQueue, #AYB.CompletedQueue > 1 and "queues" or "queue", #AYB.CompletedQueue > 1 and "need" or "needs"))
			local toon, building = string.match(AYB.CompletedQueue[1], "([^/]+)/(.+)")
			AYB.DisplayCompletedSingleShipment(toon)
			AYB.CompletedQueue = {}
		end
	elseif onDemand then
		AYB.Print("Everyone's queues are running smoothly, Commander!")
	end
end

function AYB.DisplayCompletedSingleShipment(toon)
	local name = toon:match("([^-]+)-.+")
	GarrisonLandingPageMinimapButton.MinimapLoopPulseAnim:Play();
	GarrisonBuildingAlertFrame.Name:SetFormattedText("Work order up! (%s)", name);
	AlertFrame_AnimateIn(GarrisonBuildingAlertFrame);
	AlertFrame_FixAnchors();
	PlaySound("UI_Garrison_Toast_BuildingComplete");
end

function AYB.DisplayCompletedShipmentReport(last)
	local done, chars, toonCount, currentComplete, whichToon, msg, toon, key, shipment = {}, {}, 1, 0, "", ""
	for k, v in ipairs(AYB.CompletedQueue) do
		key, shipment = string.match(v, "([^/]+)/(.+)")
		toon = string.match(key, "([^-]+)")
		if key == me then
			currentComplete = currentComplete + 1
		else
			if not done[toon] then
				done[toon] = {}
				if toon ~= string.match(me, "([^-]+)") then
					tinsert(chars, key)
				end
			end
			tinsert(done[toon], shipment)
		end
	end
	whichToon = chars[random(1, #chars)]
	local speakerRace = AllYourBaseVars[whichToon].Race
	local total = ", for a total of "..#AYB.CompletedQueue.." work order queues."
	local intro = AllYourBase.StatusIntros.Shipments[speakerRace][random(#AllYourBase.StatusIntros.Shipments[speakerRace])]
	msg = (currentComplete > 0 and (format("%s I see you have completed %d %s. ", intro, currentComplete, (currentComplete == 1 and "queue" or "queues")))) or intro.." "
	for k, v in pairs(done) do
		msg = msg .. format("%s %s completed %d %s: ", (k == string.match(whichToon, "([^-]+)") and "I") or k, (k == string.match(whichToon, "([^-]+)")) and "have" or "has", #v, (#v == 1 and "queue" or "queues"))
		for l, w in ipairs(v) do
			if #v == 1 then
				msg = msg .. w .. ". "
			elseif l == #v then
				msg = msg .. "and " .. w .. ". "
			else
				msg = msg .. w .. ", "
			end
		end
	end
	AYB.FakeWhisper(whichToon, msg)
end

function AYB.FakeWhisper(character, msg)
	ChatFrame_MessageEventHandler(ChatFrame1, "CHAT_MSG_WHISPER", msg, character, "Orcish", "", "", "", "", "", "", "", "1")
	PlaySound("TellMessage")
end

SLASH_ALLYOURBASE1 = "/ayb"
SlashCmdList["ALLYOURBASE"] = function(msg)
	AYB.SlashHandler(msg)
	end
	
function AYB.TextToSecs(timeLeft)
	local hr, mins, secs
	if string.find(timeLeft, "hr") then
		hr = string.match(timeLeft, "(%d+) hr")
	end
	if string.find(timeLeft, "min") then
		mins = string.match(timeLeft, "(%d+) min")
	end
	hr = hr or 0; mins = mins or 0
	return ((hr * 3600) + (mins * 60))
end

function AYB.SecsToText(timeLeft)
	local hr, mins, secs = math.floor(timeLeft / 3600), math.floor(timeLeft / 60) % 60, timeLeft % 60
	return format("%d hr, %d min, %d sec", hr, mins, secs)
end

AYB.Main:SetScript("OnEvent", AYB.Main.OnEvent)
AYB.Main:SetScript("OnUpdate", AYB.Main.OnUpdate)
AYB.ShipmentUpdater:SetScript("OnUpdate", AYB.ShipmentUpdater.OnUpdate)
AYB.WhichCrafter:SetScript("OnEvent", AYB.ParseCrafter)
-- AYB.WhichCrafter:SetScript("OnUpdate", AYB.WhichCrafter.OnUpdate)